// C Source File
// Created 26/10/2002; 14:56:41

#include "game.h"

// Macro pour les 'SWAP'
#define ASM_EXCHANGE(val1,val2) asm volatile ("exg %0,%1" : "=d" (val1),"=d" (val2) : "0" (val1),"1" (val2) : "memory","cc")
#define abso(x) ((x) >= 0 ? (x) : -(x))



void alloc_arrays(void)
{
	shipAng    = (Angle*) malloc((SHIP_NB + 2) * sizeof(Angle));
	shipCentre = (Vertex*) malloc((SHIP_NB + 2) * sizeof(Vertex));
	ptrProj    = (ScrPoint*) malloc((MAX_POINTS) * sizeof(ScrPoint));
	
	if ((!shipAng) || (!shipCentre) || (!ptrProj)) exit_proc(MEM_ERROR);
}

void free_arrays()
{
	free_sure(shipAng);  
	free_sure(shipCentre);
	free_sure(ptrProj);

	free_sure(ptrExtShipV); // librer l'espace seuleument si il a t allou
	free_sure(ptrExtShipL);
}    


/******************************************* Ecran de slection des vaisseaux *******************************************/

short ship_selection(void)
{
#define TOTAL_SHIPS (SHIP_NB + nbExtShip)	
	short key_down, ship, ship_app = 0;
	
	
	ScreenCentre.y = LCD_HEIGHT / 2; // rtablit le centre de l'cran au milieu de l'cran (en y : en x c'est deja ok)
	fatalCollision = FALSE;
	Camera.y = 0;
	
	for (ship = 0; ship < SHIP_NB + 1; ship++)
		ship_set(ship, 0, -10, -20, 0, 128, 0);
	
	ship = 0;
// Ecran de selection de vaisseau
	ClrScr();
	FontSetSys(F_4x6); // Petite police de caractres
// affiche l'entte
	DrawStr(XOFFSET + 50, 0, ":: Select a ship ::", A_NORMAL);
	FastDrawLine(Vscreen, 0, 6, LCD_WIDTH - 1, 6, A_NORMAL); 		
// affiche le footer
	DrawStr(XOFFSET + 0, LCD_HEIGHT - 6, "Arrows :: select & turn the ship - Enter :: start", A_NORMAL);
	FastDrawLine(Vscreen, 0, LCD_HEIGHT - 8, LCD_WIDTH - 1, LCD_HEIGHT - 8, A_NORMAL);
// affiche le footer et l'entte
	memcpy(LCD_MEM, Vscreen, LCD_SIZE);
	
	key_down = 1; // touche prsse en ce moment (la touche ENTER)
	
	while (!(_keytest(RR_ENTER2) && !key_down))
		{
		if (!_rowread(0x00)) key_down = 0;	// si aucune touche presse, changer key_down
		memset(Vscreen + 7*30, 0, (LCD_HEIGHT - 15) * 30);
		
// Affiche les flches
		draw_wire_object(arrowVertices, 7, arrowLines, 7, noEnds, &(arrowCentre[1]), &(arrowAng[1])); // dessiner la flche de gauche
		draw_wire_object(arrowVertices, 7, arrowLines, 7, noEnds, &(arrowCentre[0]), &(arrowAng[0])); // dessiner la flche de droite
// Affiche le nom de la classe du vaisseau
		FontSetSys(F_4x6); // petite police de caractres
		DrawStr(ScreenCentre.x + classNamesShift[shipClass[ship_app]], 8, classNames[shipClass[ship_app]], A_NORMAL);
// Affiche le nom du vaisseau
		FontSetSys(F_6x8); // moyenne police de caractres
		DrawStr(ScreenCentre.x + shipNamesShift[ship_app], 22  + YOFFSET, shipNames[ship_app], A_NORMAL); 	// affiche le nom du vaisseau avec un dcalage par rapport au centre de l'cran pour centrer toujours le nom quelle que soit sa taille
		FontSetSys(F_4x6); // Petite police de caractres
// Affiche l'ellipse
		DrawClipEllipse (ScreenCentre.x, 73 + YOFFSET, 35, 8, &(SCR_RECT){{0, 0, 159, 99}}, A_NORMAL);
// Affiche le vaisseau
		draw_wire_object(shipVertices[ship_app], shipNumVertices[ship_app], shipLines[ship_app], shipNumLines[ship_app], noEnds, &(shipCentre[ship_app]), &(shipAng[ship_app]));

// efface la bas de l'cran au cas ou ca dborde dans la barre
		memset(Vscreen + (LCD_HEIGHT - 8) * 30, 0, (8 * 30)); 
// Copie l'cran virtuel dans lequel on a crit sur le LCD
		memcpy(LCD_MEM, Vscreen, (LCD_HEIGHT - 8) * 30); // Affiche d'un coup l'cran virtuel (sauf le bas) (et ainsi il n'y a pas de dlai entre l'affichage des premires et des dernires lignes

// faire tourner le vaisseau et les flches		
		shipAng[ship_app].y += 2;
		arrowAng[0].x += 4;
		arrowAng[1].x -= 4;

		if ((_keytest(RR_LEFT)) && !key_down) 
			{
			if (ship-- == 0) ship = TOTAL_SHIPS - 1;
			if (ship >= SHIP_NB) load_ship(ptrNames + 18 * (ship - SHIP_NB));
			ship_app = (ship >= SHIP_NB ? SHIP_NB : ship);
			shipAng[ship_app].x = 0;
			shipAng[ship_app].y = 128;
			key_down = 1; // touche prsse en ce moment
			}
		if ((_keytest(RR_RIGHT)) && !key_down)
			{
			if (++ship == TOTAL_SHIPS) ship = 0;
			if (ship >= SHIP_NB) load_ship(ptrNames + 18 * (ship - SHIP_NB));
			ship_app = (ship >= SHIP_NB ? SHIP_NB : ship);
			shipAng[ship_app].x = 0;
			shipAng[ship_app].y = 128;
			key_down = 1; // touche prsse en ce moment
			}
			
		if (_keytest(RR_UP)) shipAng[ship_app].x += 2;		// fait tourner le vaisseau dans un sens
		if (_keytest(RR_DOWN)) shipAng[ship_app].x -= 2;	// et dans l'autre sens
		if (_keytest(RR_ESC)) return(-1);
		}
		
	return(ship_app);
}	





/*************************************** Fin de la fonction selection de vaisseau ***********************************/

/**************************************** Fonctions annexes **********************************************/

void load_ship(char* fileFullName)
{
#define CODE_SHIP 21251

	short i, code, s_bonus, temp;
	int points,lines;
	FILE *fp1;

	fp1 = fopen(fileFullName,"rb"); 
	
	fread(&code,sizeof(code),1,fp1);
	
	fread(&points,sizeof(points),1,fp1); // lecture du nombre de points du vaisseau
	fread(&lines,sizeof(lines),1,fp1); // lecture du nombre de lignes du vaisseau
	 
  ptrExtShipV = (Vertex*) realloc(ptrExtShipV, points * sizeof (Vertex)); // alloue de l'espace pour les points du vaisseau
  ptrExtShipL = (Line*) realloc(ptrExtShipL, lines * sizeof (Line)); // alloue de l'espace pour les lignes du vaisseau
  
  if ((!ptrExtShipV) || (!ptrExtShipL)) exit_proc(MEM_ERROR);
  /*ClrScr();
  printf_xy(0, 0, "alloc : %x", ptrExtShipV);
  printf_xy(0, 10, "fix : %x", shipVertices[0]);
  memcpy(LCD_MEM, Vscreen, LCD_SIZE);
    
  while(_keytest(RR_ENTER));
  while(!_keytest(RR_ENTER));*/
  
// lit les donnes sur le vaisseau dans le fichier
	fread(ptrExtShipV, sizeof(Vertex), points, fp1);
	fread(ptrExtShipL, sizeof(Line), lines, fp1);
	fread(extShipEnds, sizeof(short), 9, fp1);
	fread(extShipCanons, sizeof(short), 2, fp1);
	fread(&s_bonus, sizeof(short), 1, fp1);

	fclose(fp1); // ferme le fichier SHIP

	for (i = 0; i < points; i++)
		{
		ptrExtShipV[i].x = -ptrExtShipV[i].x;
		ptrExtShipV[i].y = -ptrExtShipV[i].y;
		//ASM_EXCHANGE(ptrExtShipV[i].x, ptrExtShipV[i].z);
		temp = ptrExtShipV[i].x;
		ptrExtShipV[i].x = ptrExtShipV[i].z;
		ptrExtShipV[i].z = temp;	
		}

  if (!(ptrProj = (ScrPoint*) realloc(ptrProj, max(MAX_POINTS,points) * sizeof(ScrPoint)))) exit_proc(MEM_ERROR);
  
  strcpy(shipNames[EXT_SHIP_NB] ,(const char*) (strpbrk(fileFullName, "\\")+1) ); // recherche le nom du vaisseau (situ apres le \ et le copie dans name
      
	shipVertices[EXT_SHIP_NB] = ptrExtShipV;
	shipLines   [EXT_SHIP_NB] = ptrExtShipL;
	shipEnds    [EXT_SHIP_NB] = extShipEnds;
  shipCanons    [EXT_SHIP_NB] = extShipCanons;
  shipNumVertices[EXT_SHIP_NB] = points;
	shipNumLines   [EXT_SHIP_NB] = lines;	// remplit les tableaux dfinissants les lments des vaisseaux
	shipSizeBonus[EXT_SHIP_NB] = (float)(s_bonus);
	shipSizeBonus[EXT_SHIP_NB] = (shipSizeBonus[EXT_SHIP_NB]/10)+0.1;

}





/***************************************************** Partie *****************************************************/

void game(short ship, short game_mode)

/* Structure de la fonction pour le mode 'compet'
- initialisations
- boucle du jeu :
	- Lecture du clavier (touches de dplacement)
	- calculs de dplacement du vaisseau (en fonction des angles)
	- Initialisation de missiles (ou laser) si tirs de missiles
	- Affichage des objets 3D
	- Affichage des lments non 3D
 (fin de la boucle)
- boucle explosion du vaisseau
- boucle monte du score
- Appel de la fonction new_input (highscores)
	
*/

{
	short i,j, astNumber, missIndex, shipBackup, ringFailed, rayon, ringCount, current_line;
	short seeExplosion, missCollision = 0;
	
	const char* comments[6]= {"You call that flying ?!", "Crash and burn !", "You could do better...", "Nothing special...", "Simply amazing !", "Breathtaking !!"}; // commentaire pour une note comprise entre 0 et 3, puis entre 4 et 7, etc...
	
	float score;
	Vertex Work;
	Vertex Work2;
	
	unsigned char missileG_sprt[] = {0x40, 0xe0, 0xe0, 0xe0, 0xe0}; // Sprite missile
	
/*************************************************** Initialisations *************************************************/	

	ship_set(ship, 0, -20, -20, 0, 0, 0);
	
	camera_mode = optionsData.cameraMode; // mode par dfaut de camera choisi dans les options
	ctMod = optionsData.controlsMode;
	colMod = game_mode;	// mode de collision (astroides en mode compet et anneaux en mode training)
	trajMod = optionsData.trajMode; // mode de trajectoire des astroides
	spiralSpeed = 2;
	FontSetSys(F_4x6); // Petite police de caractres pour afficher la distance
	
	// calcule dans rayon le rayon max du vaisseau
		rayon = 0;
		for (i = 0; i < shipNumVertices[ship]; i++) 
			{
			j = square(shipVertices[ship][i].x) + square(shipVertices[ship][i].y) + square(shipVertices[ship][i].z);
			if (j > rayon) rayon = j;
			}
		rayon = (short) sqrt((float)rayon) + 1;
	
/***********************************************************************************************************/
/*****************************************   MODE COMPET   *************************************************/
/***********************************************************************************************************/	

	
	if (game_mode == COMPET)
		do
		{
		camera_set(0, 0, 50);
		dist = 0;	// aucune distance parcourue
		astShoot = 0; // pas encore d'astroides shoots
		shipBackup = MISS_NB; // cette variable contient en mmoire le numro du vaisseau quand un missile guid est tir, sinon est est le numro du modle "vaisseau" missile guid.
		seeExplosion = 0;
		missileGstock = 3;	// 3 missiles guids disponibles
		missileGflicker = 0; // pas de clognotement
		fatalCollision = 0;
		x_lock = FALSE;
		z_lock = FALSE;
		max_x_loop = 4;
		cont_x = 0;
		max_y_loop = 4;
		cont_y = 0;
				
		xfield = 50;
		yfield = 40;
		rfield = 70;
		pathCentre[0].x -= 50;
		pathCentre[1].x += 50;
		
		for (i=0; i < MAX_MISSILES; i++) missileDist[i] = 0; // pas de missiles
	
		for (i = 0; i <= 4; i++)
			{
			if (trajMod == LINE)
				{
				astCentre[i].x = random(2 * xfield + 1) - xfield;
				astCentre[i].y = random(2 * yfield + 1) - yfield; // position initiale des astroides
				}
			else
				{
				astRay[i] = random (rfield);
				astPolAng[i] = (unsigned char) random(256);
				astCentre[i].x = (astRay[i] * cos128_table[astPolAng[i]])>>7;
				astCentre[i].y = (astRay[i] * sin128_table[astPolAng[i]])>>7;
				}
				
			astCentre[i].z = -1000 - (100 * i);
			
			astState[i] = PRESENT;
			astPower[i] = 3;
			}
			
		intro_anim(ship, game_mode);
		
/**************************************************************************************************************
 														Boucle du jeu (dfilement des astroides)...
**************************************************************************************************************/
#ifdef COMPILE_FOR_TI89		
		while ((!_keytest(RR_CLEAR)) && (!fatalCollision))
#else	
		while ((!_keytest(RR_ESC)) && (!fatalCollision))
#endif
			{	
	
			fatalCollision = key_read(ship, shipBackup, game_mode); // lecture des touches et menu pause
			if (_keytest(RR_PLUS) && spiralSpeed < 10) spiralSpeed++;
			if (_keytest(RR_MINUS) && spiralSpeed > 2) spiralSpeed--;
			
			move_ship(ship); // dplace le vaisseau en fonction de ses angles et du mode de commande
	
/*************************************** Initialisation de tirs de missile **************************************/
		
// Tir de missiles
#ifdef COMPILE_FOR_TI89
			if (_keytest(RR_2ND) && !(missileDist[MAX_MISSILES - 1]) && !missG(ship)) // si appui sur 2ND et pas "MAX_MISSILES" missiles dja en train de voler et pas mode missile guid
#else
			if (_keytest(RR_F1) && !(missileDist[MAX_MISSILES - 1]) && !missG(ship)) // si appui sur F1 et pas "MAX_MISSILES" missiles dja en train de voler et pas mode missile guid
#endif
				{
				for (missIndex = 0; missileDist[missIndex] != 0; missIndex++);	// aprs cette instruction, missIndex est la premire position libre dans la liste des missiles
	
				if ((!missIndex) || (missileDist[missIndex - 1] > 4))
					{
	// maintenant on initialise les proprits du couple de missiles index par missIndex
			
					missileDist[missIndex] = 1;	// distance parcourue par les missiles initialise  0
					for (i = 0; i <= 1; i++)
						{
						Work.x = (shipVertices[ship])[ (shipCanons[ship])[i] ].x;
						Work.y = (shipVertices[ship])[ (shipCanons[ship])[i] ].y;
						Work.z = (shipVertices[ship])[ (shipCanons[ship])[i] ].z;
				
						if (!i) // calcul du vecteur missile seulement la premire fois
							{
							Work2.x = Work.x;
							Work2.y = Work.y;
							Work2.z = Work.z + MISSILE_SPEED; // le meme point que Work (le point "Canon") mais en retrait.
							}
				// Work et Work2 sont donc les "extrmits" du lance-missile
				
						rotations(&Work, &shipAng[ship]);
				
						if (!i) // calcul du vecteur missile seulement la premire fois
							{
							rotations(&Work2, &shipAng[ship]); // on recalcule la position de ces deux points compte-tenu de la position actuelle
							missileVector[missIndex].x = Work.x - Work2.x;
							missileVector[missIndex].y = Work.y - Work2.y;
							missileVector[missIndex].z = Work.z - Work2.z;
							}
				
						missileCentre[missIndex][i].x = Work.x + shipCentre[ship].x;
						missileCentre[missIndex][i].y = Work.y + shipCentre[ship].y; // initialise la position de dpart du missile
						missileCentre[missIndex][i].z = Work.z + shipCentre[ship].z;
						missileAng[missIndex][i].x = shipAng[ship].x;
						missileAng[missIndex][i].y = shipAng[ship].y;	// et l'angle (le meme que celui du vaisseau)
						missileAng[missIndex][i].z = shipAng[ship].z;
						}
					}
				}
		
		
		// Tir de missile guid
#ifdef COMPILE_FOR_TI89
			if (_keytest(RR_DIAMOND) && (missileGstock) && !missG(ship))
#else
			if (_keytest(RR_F5) && (missileGstock) && !missG(ship))
#endif
				{
				shipCentre[MISS_NB].x = shipCentre[ship].x;
				shipCentre[MISS_NB].y = shipCentre[ship].y - 6;
				shipCentre[MISS_NB].z = shipCentre[ship].z; // initialise la position du missile guid
				shipAng[MISS_NB].x = shipAng[ship].x;
				shipAng[MISS_NB].y = shipAng[ship].y;
				shipAng[MISS_NB].z = shipAng[ship].z; // initialisation des angles du missile guid
				shipBackup = ship;	// on sauvegarde le numro du vaisseau courant dans shipBackup (shipBackup qui vaut MISS_NB le reste du temps)
				ship = MISS_NB; // le vaisseau courant devient pour un temps MISS_NB (c'est  dire le numro du missile guid)
				missileGDist = 0;	  // distance parcourue nulle pour l'instant
				missileGstock--;		// et un missile de moins, un !
				missileGflicker = 0; // arrte le clignotement
				seeExplosion = 0;		// variable utilise quand le missile rentre dans un astroide et elle doit etre  zro avant
				}
		
/****************************************** Affichage de tous les elements 3D **************************************/
		
			ClrScr();
		
		//sprintf(buffer, "%d, %d; %d, %d", find_speed(uang_x), find_speed(uang_z), max_x_loop, max_y_loop);
		//DrawStr(0, 8, buffer, A_NORMAL);
				
			if (missG(ship)) // si c'est le missile guid qui vole
				{
				shipCentre[MISS_NB].z--;
			
					// repositionne la camera derrire le vaisseau
				Camera.x += sign(shipCentre[MISS_NB].x - Camera.x);
				Camera.y += sign(shipCentre[MISS_NB].y + 10 - Camera.y);
				if (abs(shipCentre[MISS_NB].z + 45 - Camera.z) <= 1) Camera.z = shipCentre[MISS_NB].z + 45;
				Camera.z += 2 * sign(shipCentre[MISS_NB].z + 45 - Camera.z); // repositionnement de la camra  chaque fois derriere le missile guid
			
		// dessine le missile guid
				if (!seeExplosion) missCollision = draw_wire_object(shipVertices[MISS_NB], shipNumVertices[MISS_NB], shipLines[MISS_NB], shipNumLines[MISS_NB], shipEnds[MISS_NB], &shipCentre[MISS_NB], &shipAng[MISS_NB]);
			
				shipAng[shipBackup].x += sign(-(signed char) shipAng[shipBackup].x);
				shipAng[shipBackup].z += sign(-(signed char) shipAng[shipBackup].z); // rtablit progressivement l'avion en position horizontale
		// dessine l'avion pour l'effet terrible du dpart du missile :)
				if (missileGDist < 12) draw_wire_object(shipVertices[shipBackup], shipNumVertices[shipBackup], shipLines[shipBackup], shipNumLines[shipBackup], shipEnds[shipBackup], &shipCentre[shipBackup], &shipAng[shipBackup]);
			
		// Controle grossier de la collision du vaisseau avec les astroides
				fatalCollision = col_check(shipCentre[shipBackup].x, shipCentre[shipBackup].y, shipCentre[shipBackup].z);
				
				FastDrawHLine(Vscreen, LCD_WIDTH-101 + (missileGDist>>1), LCD_WIDTH - 2, 1, A_NORMAL);
				FastDrawHLine(Vscreen, LCD_WIDTH-101 + (missileGDist>>1), LCD_WIDTH - 2, 2, A_NORMAL); // affiche le temps de vol restant du missile
				
				if ((++missileGDist == 200) || fatalCollision) 
					{
					ship = shipBackup; // au bout de trop longtemps, revenir au vaisseau
					camera_set(0, 0, 50);			 // remet la camra en position initiale
					}
				
				if (missCollision && !seeExplosion) // si le missile guid a heurt un astroide
					{
					explose_ast(missCollision - 1);	// initialise les paramtre d'explosion de l'astroide heurt
					missCollision = 0;
					seeExplosion = 25;
					}
				
				if (seeExplosion)
					if ((--seeExplosion) == 0)
						{
						ship = shipBackup; // revenir au vaisseau
						if (camera_mode == FIX) camera_set(0, 0, 50);			 // remet la camra en position initiale
						else
							{
							Camera.x = shipCentre[ship].x;
							Camera.y = shipCentre[ship].y + 10;
							Camera.z = shipCentre[ship].z + 35;
							}
						shipAng[ship].x = 0;
						shipAng[ship].z = 0;	// rtablit un angle nul pour l'avion au cas ou ceux ci seraient partis en couille
						}
				
				}
			else
				{
				camera_move(ship);
			
			// Dessine le vaisseau		
				fatalCollision |= draw_wire_object(shipVertices[ship], shipNumVertices[ship], shipLines[ship], shipNumLines[ship], shipEnds[ship], &shipCentre[ship], &shipAng[ship]);
				}

			draw_ast(); // dessine les astroides suivant leur tat (present, absent, en cours d'explosion)

			
// Affiche les missiles si il y en a de tirs et controle leur collision avec les astroides
			for (missIndex = 0; missileDist[missIndex]; missIndex++)
				{ 
				for (i = 0; i <= 1; i++) 
					{
					astNumber = (draw_wire_object(missileVertices, MISS_VERT_NB, missileLines, MISS_LINES_NB, missileEnds, &missileCentre[missIndex][i], &missileAng[missIndex][i])); // si des missile sont tirs, les afficher
				
					if (astNumber)
						{
						astNumber--;	// astNumber est l'indice de l'astroide dans le tableau
					
						slide_missile_array(missIndex + 1);						
						missIndex--;	// annule l'effet de la prochaine instruction d'volution du for sur missIndex car le prochain couple de missiles  analyser est  la place de celui qui vient d'exploser
					
						if (!(--astPower[astNumber]))
							{
							explose_ast(astNumber);
							break; // termine la boucle for i = 0 to 1
							}
						}
					}
				}

	
			draw_pathway();	
		
/******************************************* Affichage des graphismes non 3D ***************************************/
			graphism_2d(ship);
			
			sprintf(buffer, "%ld", dist);
			DrawStr(0, 0, buffer, A_NORMAL);
		
			if (missileGflicker) missileGflicker--;
			if (missileGstock) for (i = 0; i < missileGstock; i++) if (!((i == missileGstock - 1) && (missileGflicker % 10) > 5)) Sprite8_OR(i*4, LCD_HEIGHT - 5, 5, missileG_sprt, Vscreen); // dessine les missiles guids disponibles, pour le dernier grer le clignotement grace  missilrGflicker
		
			memcpy(LCD_MEM, Vscreen, LCD_SIZE); // Affiche d'un coup l'cran virtuel (et ainsi il n'y a pas de dlai entre l'affichage des premires et des dernires lignes
		
			move_objects((missG(ship) ? ship : shipBackup));
		
			}	// fin de la boucle de dfilement
	
		
/*************************************** Explosion du vaisseau  *****************************************/
	
		fatalCollision = 1; // au cas ou l'utilisateur  quitt la boucle en appuyant sur CLEAR, c'est pour viter que le temps de vol continue a tourner pendant l'explosion

		for (i = 0; i < MAX_MISSILES; i++) missileDist[i] = 0; // dsactive les missiles qui pourraient tre en train de voler

		for (i = 0; i < 6; i++)
			{
			toleCentre[i].x = shipCentre[ship].x;
			toleCentre[i].y = shipCentre[ship].y;
			toleCentre[i].z = shipCentre[ship].z;
			}
	
		for (j = 0; j < 30; j++)
			{
			toleCentre[0].x++;
			toleCentre[1].x--;
			toleCentre[2].y++;
			toleCentre[3].y--;
			toleCentre[4].z++;
			toleCentre[5].z--;
			for (i = 0; i < 6; i++)
				{
				toleAng[i].x++;
				toleAng[i].y++;
				toleAng[i].z++;
				}
		
			ClrScr();
			draw_ast();
			for (i = 0; i <= 5; i++) draw_wire_object(toleVertices, 4, toleLines, 4, noEnds, &toleCentre[i], &toleAng[i]);
			draw_pathway();
			memcpy(LCD_MEM, Vscreen, LCD_SIZE); // Affiche d'un coup l'cran virtuel (et ainsi il n'y a pas de dlai entre l'affichage des premires et des dernires lignes
		
			move_objects((missG(ship) ? ship : shipBackup));
			}
		
/****************************** Monte de l'cran de score *******************************************/
	
		if (missG(ship)) ship = shipBackup;	// si c'tait le missile guid en train de voler (quand il y a eu un appui sur ESC), rtablir le bon numro de vaisseau
		score = (long) (dist * shipSizeBonus[ship] * (trajMod == SPIRAL ? 2 : 1) + (100 * astShoot));	// calcule le score
	
		frame(24 + XOFFSET, 4 + YOFFSET, 111, 46, Vscreen);
		detail_score(24 + XOFFSET, 4 + YOFFSET, "Total Score", score, ship);
		memcpy(LCD_MEM, Vscreen, LCD_SIZE); // Affiche l'cran virtuel
		
		
/************************************** Aiguillage sur la fonction highscores ***************************************************/		

		new_entry(ctMod-1, score);	// highscores
		
		frame(24 + XOFFSET, 74 + YOFFSET, 111, 16, Vscreen);
		DrawStr(35 + XOFFSET, 77 + YOFFSET, "Restart with the same ship" , A_NORMAL);
		DrawStr(35 + XOFFSET, 84 + YOFFSET, "Go to the hall of fame" , A_NORMAL);
		
		Sprite8_OR(26 + XOFFSET, 76 + YOFFSET, 7, arrow_sprt, Vscreen); // afficher le curseur
		current_line = 1;
		memcpy(LCD_MEM, Vscreen, LCD_SIZE); // Affiche l'cran virtuel
			
		key_down = 0;
		i = 0;	// flag pour l'appui sur la touche ESC	
		while (!_keytest(RR_ENTER2) || key_down)
			{
			if (!_rowread(0x00)) key_down = 0;	// si aucune touche presse, changer key_down
			if ((_keytest(RR_DOWN) || _keytest(RR_UP)) && !key_down)
				{
				Sprite8_XOR(26 + XOFFSET, 76 + YOFFSET + 7 * (current_line-1), 7, arrow_sprt, Vscreen);
				current_line = 3 - current_line;
				Sprite8_XOR(26 + XOFFSET, 76 + YOFFSET + 7 * (current_line-1), 7, arrow_sprt, Vscreen);
				key_down = 1; // message : touche prsse (et la lecture des touches est inactive jusqu'a ce que la touche soit relache)
				memcpy(LCD_MEM, Vscreen, LCD_SIZE); // Affiche l'cran virtuel
				}
			if (_keytest(RR_ESC))
				{
				i = 1; // set the flag...
				break;
				}
			}
		
		} while (current_line == 1 && !i); // fin du mode ARCADE : reboucle si l'option choisie est "Restart ..."
				
		
/***********************************************************************************************************/
/*****************************************   MODE TRAINING   ***********************************************/
/***********************************************************************************************************/	
	else // mode TRAINING
		{
		x_lock = FALSE;
		z_lock = FALSE;
		max_x_loop = 4;
		cont_x = 0;
		max_y_loop = 4;
		cont_y = 0;

		xfield = 100;
		yfield = 80;
		pathCentre[0].x -= 100;
		pathCentre[1].x += 100;
		
		for (i = 0; i <= 3; i++)
			{
			astCentre[i].x = random(2 * xfield + 1) - xfield;
			astCentre[i].y = random(2 * yfield + 1) - yfield; // position initiale des astroides
			astCentre[i].z = -1000 - (400 * i);
			astAng[i].x = 0;
			astAng[i].y = 0;
			astAng[i].z = 0;
			}
			
		ringCount = 4;
		
		nbRingPassed = 0;
		nbRingSuccess = 0;
		ringFailed = FALSE;
		activeRing = 0; // numro de l'anneau actif (cad sur lequel il y a les flches)
		
		intro_anim(ship, game_mode);
		
/**************************************************************************************************************
 														Boucle du jeu (dfilement des astroides)...
**************************************************************************************************************/
#ifdef COMPILE_FOR_TI89		
		while (!_keytest(RR_CLEAR) && nbRingPassed < RING_NB)
#else	
		while (!_keytest(RR_ESC) && nbRingPassed < RING_NB)
#endif
			{	
			if (key_read(ship, shipBackup, game_mode)) break; // lecture des touches et menu pause
			move_ship(ship); // dplace le vaisseau en fonction de ses angles et du mode de commande
			dist++;
	
/****************************************** Affichage de tous les elements 3D **************************************/
		
			ClrScr();
			camera_move(ship);
			// Dessine le vaisseau		
			i = draw_wire_object(shipVertices[ship], shipNumVertices[ship], shipLines[ship], shipNumLines[ship], shipEnds[ship], &shipCentre[ship], &shipAng[ship]);
			ringFailed |= i; // opration faite en 2 tapes sinon une fois l'anneau pass, la fonction n'est plus xecute.
			
			if ((astCentre[activeRing].z - shipCentre[ship].z) > rayon) 
				{
				activeRing++;
				nbRingPassed++;
				if (!ringFailed) nbRingSuccess++;
				ringFailed = FALSE;
				}
			
			move_rings();
			draw_wire_object(arrow2Vertices, 7, arrowLines, 7, noEnds, &(Vertex){astCentre[activeRing].x - 70, astCentre[activeRing].y, astCentre[activeRing].z}, &(Angle){0, 0, 0});
			draw_wire_object(arrow2Vertices, 7, arrowLines, 7, noEnds, &(Vertex){astCentre[activeRing].x + 70, astCentre[activeRing].y, astCentre[activeRing].z}, &(Angle){0, 0, 128});
			draw_wire_object(arrow2Vertices, 7, arrowLines, 7, noEnds, &(Vertex){astCentre[activeRing].x , astCentre[activeRing].y + 70, astCentre[activeRing].z}, &(Angle){0, 0, 192});
			draw_wire_object(arrow2Vertices, 7, arrowLines, 7, noEnds, &(Vertex){astCentre[activeRing].x , astCentre[activeRing].y - 70, astCentre[activeRing].z}, &(Angle){0, 0, 64});
						
			if (astCentre[0].z > 25) // Si l'astroide le plus proche est arriv en bout de course
				{
				for (i = 0; i < 3; i++) // dcaler les astroides et toutes les donnes qui vont avec
					{
					astCentre[i].x = astCentre[i + 1].x;
					astCentre[i].y = astCentre[i + 1].y;
					astCentre[i].z = astCentre[i + 1].z;
					}
				
				astCentre[3].x = random(2 * xfield + 1) - xfield; // r-initialiser la position de l'astrode en bout de course
				astCentre[3].y = random(2 * yfield + 1) - yfield;
				if (ringCount < RING_NB)	astCentre[3].z = -1575;
				else astCentre[3].z = 10; // anneau hors de l'cran (fin du jeu)
					
				activeRing--;
				ringCount++;
				}
			
			draw_pathway();
			graphism_2d(ship);
			sprintf(buffer, "%d/%d", nbRingSuccess, nbRingPassed);
			DrawStr(0, 0, buffer, A_NORMAL);
			memcpy(LCD_MEM, Vscreen, LCD_SIZE); // Affiche d'un coup l'cran virtuel (et ainsi il n'y a pas de dlai entre l'affichage des premires et des dernires lignes				
			
			}	// (fin de la boucle de dfilement)
	
	if (nbRingPassed == RING_NB) // si la sortie de la boucle est du  la fin de la partie et pas d'un appui sur ESC ou CLEAR
		{
		frame(24 + XOFFSET, 38 + YOFFSET, 111, 23, Vscreen);
		sprintf(buffer, "Training finished :", 20 - nbRingPassed);
		DrawStr(26 + XOFFSET, 41 + YOFFSET, buffer, A_NORMAL);
		sprintf(buffer, "Your score : %d/%d", nbRingSuccess, nbRingPassed);
		DrawStr(26 + XOFFSET, 48 + YOFFSET, buffer, A_NORMAL);
		DrawStr(26 + XOFFSET, 55 + YOFFSET, comments[nbRingSuccess>>2], A_NORMAL);
		memcpy(LCD_MEM, Vscreen, LCD_SIZE);
		while(!(_keytest(RR_ENTER2) || _keytest(RR_ESC)));
		}
		
	} // (fin du mode TRAINING)
	
} /* (fin de la fonction game) */


/******************************** Lecture des touches *******************************************/
short key_read(short ship, short shipBackup, short game_mode)
{
	signed char ang_x, ang_z;
	short current_line, shipp;
	float score;
	
		if ((!_keytest(RR_LEFT)) && (!_keytest(RR_RIGHT))) z_lock = FALSE;
		if ((!_keytest(RR_UP)) && (!_keytest(RR_DOWN))) x_lock = FALSE;
		
		if (_keytest(RR_LEFT) && _keytest(RR_RIGHT) && abs((signed char) shipAng[ship].z) < 9) 
			{
			shipAng[ship].z = 0;
			z_lock = TRUE;	// en cas de demande de stabilisation, z_lock (verouille la rotation autour de l'axe z) tant que les deus touches GAUCHE et DROITE n'ont pas t laches
			}
		
		missGtest = missG(ship); // n'xecuter la fonction qu'une seule fois pour la vitesse
		
/* Le vaisseau  un battement angulaire limit  +ou- 90 en mode arcade
 Le missile guid  un battement angulaire limit  +ou- 45, 
 mais pour un mme angle, il se dplace deux fois plus vite 
 (et le pas duquel il se dplace quand on appuie sur une touche flche est divis par 2)
 L'effet est donc uniquement visuel, le missile se dplace de la mme faon que le vaisseau */

		ang_z = (signed char) shipAng[ship].z; // le mme mais en sign (angle entre -64 et 64) au lieu de entre 192 et 255 ou 0 et 64
		if (_keytest(RR_LEFT) && !z_lock && (ctMod == SIM || ang_z < 64)) shipAng[ship].z += 4;
		if (_keytest(RR_RIGHT) && !z_lock && (ctMod == SIM || ang_z > -64)) shipAng[ship].z -= 4; // il y a des limites d'angle diffrentes pour les vaisseaux et pour le missile guid
		
		
		if (_keytest(RR_DOWN) && _keytest(RR_UP) && abs((signed char) shipAng[ship].x) < 9) 
			{
			shipAng[ship].x = 0;
			x_lock = TRUE;
			}
		
		ang_x = (signed char) shipAng[ship].x; // le mme mais en sign (angle entre -64 et 64) au lieu de entre 192 et 255 ou 0 et 64
		if (_keytest(RR_DOWN) && !(x_lock) && ang_x < ((ctMod == ARCADE) ? 64 : 32)) shipAng[ship].x += 4;
		if (_keytest(RR_UP) && !(x_lock) && ang_x > ((ctMod == ARCADE) ? -64 : -32)) shipAng[ship].x -= 4;  // il y a des limites d'angle diffrentes pour les vaisseaux et pour le missile guid
		
#ifdef COMPILE_FOR_TI89		
		if (_keytest(RR_F1)) camera_mode = FIX;
		if (_keytest(RR_F2)) camera_mode = MOBILE;
		if (_keytest(RR_APPS) && (shipCentre[ship].z < -20) && !missG(ship)) shipCentre[ship].z++; //
		if (_keytest(RR_ESC) && (shipCentre[ship].z > -120) && !missG(ship)) shipCentre[ship].z--; // le vaisseau en z doit rester entre -20 et -120
#else
		if (_keytest(RR_F3)) camera_mode = FIX;
		if (_keytest(RR_F7)) camera_mode = MOBILE;
		if (_keytest(RR_F2) && (shipCentre[ship].z < -20) && !missG(ship)) shipCentre[ship].z++; //
		if (_keytest(RR_F6) && (shipCentre[ship].z > -120) && !missG(ship)) shipCentre[ship].z--; // le vaisseau en z doit rester entre -20 et -120
#endif		


	// menu Pause :
#ifdef COMPILE_FOR_TI89
		if (_keytest(RR_SHIFT))
#else
		if (_keytest(RR_APPS))
#endif
			{
			current_line = 0;	// premire ligne dans le menu
			do
				{
				frame(24 + XOFFSET, 2 + YOFFSET, 111, 38, Vscreen);
				FastDrawHLine(Vscreen, 24 + XOFFSET, 24 + 111 + XOFFSET, 10 + YOFFSET, A_NORMAL);
				drawTextPage(&pausePage);	// afficher le texte
				
				if (game_mode == COMPET)
					{
					if (missG(ship)) shipp = shipBackup;	// si c'tait le missile guid en train de voler (quand il y a eu un appui sur ESC), rtablir le bon numro de vaisseau
					else shipp = ship;
					score = (long) (dist * shipSizeBonus[shipp] * (trajMod == SPIRAL ? 2 : 1) + (100 * astShoot));	// calcule le score temporaire

					frame(24 + XOFFSET, 45 + YOFFSET, 111, 46, Vscreen);
					detail_score(24 + XOFFSET, 45 + YOFFSET, "Current Score", score, ship); // affiche le dtail du score avec en bas : Current score : score
					}
				else
					{
					frame(24 + XOFFSET, 45 + YOFFSET, 111, 14, Vscreen);
					sprintf(buffer, "Rings : %d/%d", nbRingSuccess, nbRingPassed);
					DrawStr(26 + XOFFSET, 47 + YOFFSET, buffer, A_NORMAL);
					sprintf(buffer, "Rings left : %d", 20 - nbRingPassed);
					DrawStr(26 + XOFFSET, 54 + YOFFSET, buffer, A_NORMAL);
					}
					
				
				Sprite8_OR(40  + XOFFSET, pausePage.coord[current_line + 1][1] - 1, 7, arrow_sprt, Vscreen); // afficher le curseur
				memcpy(LCD_MEM, Vscreen, LCD_SIZE); // Affiche l'cran virtuel
			
				key_down = 0;
			
				while (!_keytest(RR_ENTER2) || key_down)
					{
					if (!_rowread(0x00)) key_down = 0;	// si aucune touche presse, changer key_down
					if (_keytest(RR_DOWN) && !key_down)
						{
						Sprite8_XOR(40 + XOFFSET, pausePage.coord[current_line + 1][1] - 1, 7, arrow_sprt, Vscreen);
						current_line++;
						if (current_line == 4) current_line = 0;
						Sprite8_XOR(40 + XOFFSET, pausePage.coord[current_line + 1][1] - 1, 7, arrow_sprt, Vscreen);
						key_down = 1; // message : touche prsse (et la lecture des touches est inactive jusqu'a ce que la touche soit relache)
						memcpy(LCD_MEM, Vscreen, LCD_SIZE); // Affiche l'cran virtuel
						}
				// monte le curseur
					if (_keytest(RR_UP) && !key_down)
						{
						Sprite8_XOR(40 + XOFFSET, pausePage.coord[current_line + 1][1] - 1, 7, arrow_sprt, Vscreen);
						current_line--;
						if (current_line == -1) current_line = 3;
						Sprite8_XOR(40 + XOFFSET, pausePage.coord[current_line + 1][1] - 1, 7, arrow_sprt, Vscreen);
						key_down = 1; // message : touche prsse (et la lecture des touches est inactive jusqu'a ce que la touche soit relache)
						memcpy(LCD_MEM, Vscreen, LCD_SIZE); // Affiche l'cran virtuel
						}
					}
				
				switch(current_line)
					{
					case 1:
					return 1;
					
					case 2:
					off(); // teint la caltos
					break;
					
					case 3:
					while(_keytest(RR_ENTER2));	// ne rien faire tant que l'utilisateur ne relache pas la touche
					exit_proc(0);
					}
				} while (current_line == 2); // pour que ca refasse le menu pause quand on rallume la caltos
			}
			
	return 0;
	}

/************************************** Calculs de dplacement du vaisseau ************************************/

void move_ship(short ship)
	{
	unsigned char ang;
	short x_step, y_step;
	unsigned char uang_x, uang_z;
	
// dplace le vaisseau en fonction de son angle
		if (ctMod == ARCADE)
			{
		
			if (shipAng[ship].z)
				{ 
				ang = shipAng[ship].z;
			
				x_step = (ang < 128 ? -1 : 1);
				max_x_loop = (64 - (ang < 128 ? ang : 256 - ang)) >>4;	
				if (max_x_loop > 1) max_x_loop--; // les valeurs possibles tainent 1,2,3,4, maintenant c'est dans le mme ordre 1,1,2,3
				if (cont_x > max_x_loop) cont_x = max_x_loop; // on a peut etre diminu max_x_loop, si cont_x est plus grand, on le diminue
				if (cont_x == max_x_loop) 
					{
					if (((x_step > 0) && (shipCentre[ship].x < xfield)) || ((x_step < 0) && (shipCentre[ship].x > -xfield))) shipCentre[ship].x += x_step;
					cont_x = 0;
					}
				else
					cont_x++;
				}
		
			if (shipAng[ship].x)
				{
				ang = shipAng[ship].x;
			
				y_step = (ang < 128 ? 1 : -1);
				max_y_loop = (64 - (ang < 128 ? ang : 256 - ang)) >>4;	
				if (max_y_loop > 1) max_y_loop--; // les valeurs possibles taient 1,2,3,4, maintenant c'est dans le mme ordre 1,1,2,3
				if (cont_y > max_y_loop) cont_y = max_y_loop; // on a peut etre diminu max_y_loop, si cont_y est plus grand, on le diminue
				if (cont_y == max_y_loop) 
					{
					if (((y_step > 0) && (shipCentre[ship].y < yfield)) || ((y_step < 0) && (shipCentre[ship].y > -yfield))) shipCentre[ship].y += y_step; // Si l'avion est dans les limites du "tunnel imaginaire", le dplacer
					cont_y = 0;
					}
				else
					cont_y++;
			}
		}
		else //(ctMod == SIM)
		{
		if (shipAng[ship].x)
			{
			uang_x = 2 * shipAng[ship].x;
			uang_z = shipAng[ship].z;
		
			x_step = (uang_z < 128 ? -1 : 1);
			y_step = (uang_x < 128 ? 1 : -1);
			if (uang_z > 64 && uang_z < 192) y_step = -y_step;
		
			max_x_loop = 4 - ((find_speed(uang_x) * find_speed(uang_z)) >> 2);
			max_y_loop = 4 - ((find_speed(uang_x) * (4 - find_speed(uang_z))) >> 2);
			if (cont_x >= max_x_loop) cont_x = max_x_loop;
			else if (max_x_loop != 4) cont_x++;
			if (cont_y >= max_y_loop) cont_y = max_y_loop;
			else if (max_y_loop != 4) cont_y++;
				
			if ((cont_y == max_y_loop) && (((y_step > 0) && (shipCentre[ship].y < yfield)) || ((y_step < 0) && (shipCentre[ship].y > -yfield)))) 
				{
				shipCentre[ship].y += y_step;
				cont_y = 0;
				}
			
			if ((cont_x == max_x_loop) && (((x_step > 0) && (shipCentre[ship].x < xfield)) || ((x_step < 0) && (shipCentre[ship].x > -xfield))))
			  {
			  shipCentre[ship].x += x_step;
				cont_x = 0;
				}
		
			}
	
		}
	}

	
/************************************** Fonctions de calculs et affichage 3D **************************************************/

short draw_wire_object(Vertex* ptrVertices, short verticesNum, Line* ptrLines, short linesNum, short* ptrObjEnds, Vertex* ptrObjectCentre, Angle* ptrAng)
{
	short p, l, i, message, collision = 0;
	Vertex Work;
	
	for (p = 0; p < verticesNum; p++) // pour tous les points de l'objet...
		{
		Work.x = ptrVertices[p].x;
		Work.y = ptrVertices[p].y;
		Work.z = ptrVertices[p].z;
		
		rotations(&Work, ptrAng);		// fait tourner le point en fonction des angles de l'avion
		
 		Work.x += (ptrObjectCentre->x - Camera.x);
 		Work.y += (ptrObjectCentre->y - Camera.y);
 		Work.z += (ptrObjectCentre->z - Camera.z);
 		
  	message = FALSE;
		if (ptrObjEnds[0] != -1)
			{
			for (i = 1; i <= ptrObjEnds[0]; i++) if (p == ptrObjEnds[i]) message = TRUE; // on recherche si le point courant est dans la liste des extrmits de l'avion
			if (message && !collision) collision = col_check(Work.x + Camera.x, Work.y + Camera.y, Work.z + Camera.z);	// si le point courant est une extrmit et qu'il n'y a pas dja de collision avec un autre astroide
			}
			
	// Calcule les positions des points  l'cran
		if (Work.z >= -10)
			ptrProj[p].x = 30000;	// si le point est derrire l'cran... le signaler avec cette valeur	
		else
			{
			ptrProj[p].x = ScreenCentre.x - (Distorsion * Work.x ) / Work.z ;
			ptrProj[p].y = ScreenCentre.y + (Distorsion * Work.y ) / Work.z ;
			}
		}

// Maintenant qu'on a les points  l'cran, on dessine les lignes entre ceux-ci

	short x1, x2, y1, y2, temp, out1, out2; // coordonnes intermdiaires

	for (l=0 ; l < linesNum ;l++)  // pour les 30 lignes...
		{
		x1 = ptrProj[ptrLines[l].point1].x; // premire abscisse
		y1 = ptrProj[ptrLines[l].point1].y; // premire ordonne
		x2 = ptrProj[ptrLines[l].point2].x; // seconde abscisse
		y2 = ptrProj[ptrLines[l].point2].y; // seconde ordonne
		
	// Enfin dessiner la ligne !! si elle est au moins partiellement dans l'cran
		out1 = OUT_OF_SCREEN(x1, y1);
		out2 = OUT_OF_SCREEN(x2, y2);  // ne faire qu'une fois les tests
		
		if (out1 && !out2)	// si le point 2 est dans l'cran et le point 1 hors de l'cran inverser les deux points
			{
			temp = x2;
			x2 = x1;
			x1 = temp;
			temp = y2;
			y2 = y1;
			y1 = temp;
			}
		if (!(out1 && out2) && (x1 != 30000) && (x2 != 30000)) 
			FastDrawLineClip(Vscreen, x1, y1, x2, y2); 
		}
		
	return (collision); // en mode COMPET : collision est 0 si pas de collision, sinon le numro de l'astroide avec lequel la collision a lieu (sa place dans le tableau + 1)
}											// en mode TRAINING : collision est 0 si le vaisseau est pass entirement dans l'anneaux, sinon 1



void rotations(Vertex* ptrWork, Angle* Ang)  // la position du point est pointe par ptrWork
{
		short temp, cos, sin;
		
		cos = cos128_table[Ang->x];
		sin = sin128_table[Ang->x];
		temp = ptrWork->y;
	// Rotation autour de l'axe x
		ptrWork->y = (((ptrWork->y * cos) - (ptrWork->z * sin)) >>7);
		ptrWork->z = (((temp * sin) + (ptrWork->z * cos)) >>7);
		
		cos = cos128_table[Ang->y];
		sin = sin128_table[Ang->y];
		temp = ptrWork->x;
	// Rotation autour de l'axe y
		ptrWork->x = (((ptrWork->x * cos) - (ptrWork->z * sin)) >>7);
		ptrWork->z = (((temp * sin) + (ptrWork->z * cos)) >>7);
		
		cos = cos128_table[Ang->z];
		sin = sin128_table[Ang->z];
		temp = ptrWork->x;
	// Rotation autour de l'axe z
		ptrWork->x = (((ptrWork->x * cos) - (ptrWork->y * sin)) >>7);
		ptrWork->y = (((temp * sin) + (ptrWork->y * cos)) >>7);
}


/***************************************** Affichange des lments 2D ********************************************/
void graphism_2d(short ship)
{
	short i;
	
	unsigned char lock_sprt[] = {0x06, 0x09, 0x0f, 0x0b, 0x0f}; // Sprite du cadena :

// Dessin des indicateurs d'angle
	FastDrawHLine(Vscreen, ScreenCentre.x - 32, ScreenCentre.x + 32, LCD_HEIGHT - 1, A_NORMAL);
	FastDrawHLine(Vscreen, ScreenCentre.x - 32, ScreenCentre.x + 32, LCD_HEIGHT - 2, A_REVERSE);
	FastDrawHLine(Vscreen, ScreenCentre.x - 32, ScreenCentre.x + 32, LCD_HEIGHT - 3, A_NORMAL);
	FastDrawHLine(Vscreen, ScreenCentre.x - 32, ScreenCentre.x + 32, LCD_HEIGHT - 4, A_NORMAL);
	DrawPix(ScreenCentre.x - 32, LCD_HEIGHT - 2, A_NORMAL);
	DrawPix(ScreenCentre.x + 32, LCD_HEIGHT - 2, A_NORMAL);
	for (i = ScreenCentre.x - 24; i <= ScreenCentre.x + 24; i += 8)
		{
		if (i != ScreenCentre.x) DrawPix(i, LCD_HEIGHT - 3, A_REVERSE);
		else 
			{
			DrawPix(i - 1, LCD_HEIGHT - 3, A_REVERSE);
			DrawPix(i + 1, LCD_HEIGHT - 3, A_REVERSE);
			}
		}
	FastDrawHLine(Vscreen, ScreenCentre.x - (((signed char)shipAng[ship].z)>>((ctMod == ARCADE) ? 1 : 2)) - 1, ScreenCentre.x - (((signed char)shipAng[ship].z)>>((ctMod == ARCADE) ? 1 : 2)) + 1, LCD_HEIGHT - 2, A_NORMAL);
		
	FastDrawLine(Vscreen, LCD_WIDTH - 1, ScreenCentre.y + 32, LCD_WIDTH - 1, ScreenCentre.y - 32, A_NORMAL);
	FastDrawLine(Vscreen, LCD_WIDTH - 2, ScreenCentre.y + 32, LCD_WIDTH - 2, ScreenCentre.y - 32, A_REVERSE);
	FastDrawLine(Vscreen, LCD_WIDTH - 3, ScreenCentre.y + 32, LCD_WIDTH - 3, ScreenCentre.y - 32, A_NORMAL);
	FastDrawLine(Vscreen, LCD_WIDTH - 4, ScreenCentre.y + 32, LCD_WIDTH - 4, ScreenCentre.y - 32, A_NORMAL);
	DrawPix(LCD_WIDTH - 2, ScreenCentre.y - 32, A_NORMAL);
	DrawPix(LCD_WIDTH - 2, ScreenCentre.y + 32, A_NORMAL);
	for (i = ScreenCentre.y - 24; i <= ScreenCentre.y + 24; i += 8)
		{
		if (i != ScreenCentre.y) DrawPix(LCD_WIDTH - 3, i, A_REVERSE);
		else 
			{
			DrawPix(LCD_WIDTH - 3, i - 1, A_REVERSE);
			DrawPix(LCD_WIDTH - 3, i + 1, A_REVERSE);
			}
		}
	FastDrawLine(Vscreen, LCD_WIDTH - 2, ScreenCentre.y - (((signed char)shipAng[ship].x)>>1) - 1, LCD_WIDTH - 2, ScreenCentre.y - (((signed char)shipAng[ship].x)>>1) + 1, A_NORMAL);
	
	if (camera_mode == MOBILE) Sprite8_OR(LCD_WIDTH - 8, LCD_HEIGHT - 5, 5, lock_sprt, Vscreen); // dessine le petit cadena qui correspond au mode camra fixe
}

/******************************************************************************************************************/


void move_objects(short ship)
{
	short i, j, missIndex;
		
// faire avancer tous les astroides
	for (i = 0; i < 5; i++)
		{
		astCentre[i].z += 4; 	// 4 est le pas duquel les astroides avancent  chaque fois
		if ((astState[i] == KAMIKAZE))
			{
			if (!(astCentre[i].z & 0x0008)) 	// la position dans le plan (x,y) du kamikaze ne change qu' chaque fois qu'il a avanc de 4
				{
				astCentre[i].x -= sign(astCentre[i].x - shipCentre[ship].x);
				astCentre[i].y -= sign(astCentre[i].y - shipCentre[ship].y); // reduit l'cart entre le kamikaze et le vaisseau (le vrai, pas le missile guid si c'est lui qui vole)
				}
			}
		else	
			{
			astAng[i].x++;
			astAng[i].y++;
			astAng[i].z++; // faire tourner l'astroide dans tous les sens
			}
			
		if (trajMod == SPIRAL)
			{
			if (astState[i] != KAMIKAZE) astPolAng[i] += spiralSpeed;	// fait tourner l'astroide
			astCentre[i].x = (astRay[i] * cos128_table[astPolAng[i]])>>7; // recalcule sa position en x
			astCentre[i].y = (astRay[i] * sin128_table[astPolAng[i]])>>7; // recalcule sa position en y
			}
				
		if (astState[i] == EXPLOSE) // si l'astroide est en train d'exploser
			{ 
			fragCentre[0].x--; //
			fragCentre[0].y++; //
			fragCentre[1].x++; //
			fragCentre[1].y++; //
			fragCentre[2].x++; // faire s'carter les fragments
			fragCentre[2].y--; //
			fragCentre[3].y--; //
			fragCentre[3].x--; //
			for (j = 0; j < 4; j++) 
				{
				fragCentre[j].z--;	// continuer de faire avancer les fragments
				fragAng[j].x++; //
				fragAng[j].y++; // faire tourner les fragments dans tous les sens
				fragAng[j].z++; // 
				}
			fragDist++;	// augmenter la distance parcourue par les fragments d'astroide
			if (fragDist > 30) astState[i] = ABSENT; // au bout de 30 avance des fragments, l'astre disparait
			}			
		}
		
	if (astCentre[0].z > 25) // Si l'astroide le plus proche est arriv en bout de course
		{
		for (i = 0; i < 4; i++) // dcaler les astroides et toutes les donnes qui vont avec
			{
			astCentre[i].x = astCentre[i + 1].x;
			astCentre[i].y = astCentre[i + 1].y;
			astCentre[i].z = astCentre[i + 1].z;
			astAng[i].x = astAng[i + 1].x;
			astAng[i].y = astAng[i + 1].y;
			astAng[i].z = astAng[i + 1].z;
			astState[i] = astState[i + 1];
			astPower[i] = astPower[i + 1];
			astRay[i] = astRay[i + 1];
			astPolAng[i] = astPolAng[i + 1];
			}
			
		// Initialiser le nouvel astroide
		if (trajMod == LINE)
			{
			astCentre[4].x = random(2 * xfield + 1) - xfield;
			astCentre[4].y = random(2 * yfield + 1) - yfield; // position initiale des astroides
			}
		else
			{
			astRay[4] = random (rfield);
			astPolAng[4] = (unsigned char) random(256);
			astCentre[4].x = (astRay[i] * cos128_table[astPolAng[4]])>>7;
			astCentre[4].y = (astRay[i] * sin128_table[astPolAng[4]])>>7;
			}

		astCentre[4].z = -500;
		
		if (!random(KAM_PERIODE)) 
			{
			astState[4] = KAMIKAZE;	// crer un "astroide" kamikaze
			astAng[4].x = 0;
			astAng[4].y = 128;
			astAng[4].z = 0;	// positionne le droide kamikaze avec une assiette correcte
			}
		else astState[4] = PRESENT;
		
		astPower[4] = 3;
		}
	
		
	for (missIndex = 0; missileDist[missIndex]; missIndex++)
		{
		for (i = 0; i <= 1; i++)
			{
			missileCentre[missIndex][i].x += missileVector[missIndex].x;
			missileCentre[missIndex][i].y += missileVector[missIndex].y;
			missileCentre[missIndex][i].z += missileVector[missIndex].z;		
			}
		missileDist[missIndex]++;

		if (missileDist[missIndex] > 30) // si ils sont en bout de course
			{
			missileDist[missIndex] = 0;
			slide_missile_array(missIndex + 1);	// dcaler les tableaux des donnes concernant les missiles  partir de la position missIndex + 1
			missIndex--;
			}
		}
		
	if (!fatalCollision) dist++; // incrmente la distance parcourue, si le vaisseau n'est pas crash
	if (!(dist % PERIODE_GAIN_MISSILE) && (missileGstock != FULL_STOCK)) 
		{
		missileGstock++;
		missileGflicker = 35; // initialise le clignotement de ce dernier missile rajout 
		// fonctionnement : missileGflicker dcroit  chaque pas, et si son dernier digit est infrieur  5, le sprite est affich sinon il ne l'est pas
		}
}



void slide_missile_array(short startPosition) // startPosition est la position du PREMIER ELEMENT  deplacer (vers la gauche)
{
	short i, j;

	for (j = startPosition; j < MAX_MISSILES; j++) // on dcale toute la fin, mme si la toute fin est nimporte quoi
		{
		for (i = 0; i <= 1; i++)
			{
			missileAng[j - 1][i].x = missileAng[j][i].x; //
			missileAng[j - 1][i].y = missileAng[j][i].y; ///
			missileAng[j - 1][i].z = missileAng[j][i].z; //// angle du missile n i du couple
			missileCentre[j - 1][i].x = missileCentre[j][i].x; //
			missileCentre[j - 1][i].y = missileCentre[j][i].y; ///
			missileCentre[j - 1][i].z = missileCentre[j][i].z; //// centre du missile n i du couple
			}
		missileVector[j - 1].x = missileVector[j].x; //
		missileVector[j - 1].y = missileVector[j].y; ///
		missileVector[j - 1].z = missileVector[j].z; //// Vecteur deux deux missiles
		missileDist[j - 1] = missileDist[j]; // distance deux deux missiles
		}
}


// dessine les astroides suivant leur tat (absent, en cours d'explosion ou present)
void draw_ast(void)
{
	short i, j;
	
	for (i = 0; i < 5; i++) 
		{
		switch (astState[i])
			{
			case (PRESENT):
			draw_wire_object(astVertices, AST_VERT_NB, astLines, AST_LINES_NB, noEnds, &(astCentre[i]), &astAng[i]);
			break;
			
			case (KAMIKAZE):
			draw_wire_object(kam2Vertices, KAM2_VERT_NB, kam2Lines, KAM2_LINES_NB, noEnds, &(astCentre[i]), &astAng[i]);	
			break;
				
			case (EXPLOSE):
			for (j = 0; j < 4; j++) draw_wire_object(fragVertices, FRAG_VERT_NB, fragLines, FRAG_LINES_NB, noEnds, &(fragCentre[j]), &fragAng[j]);
			}
		}
}



void explose_ast(short astNumber)
{
	short j;

	astShoot++;				// incrmenter le compteur de nombre d'astroides dtruits
	for (j = 0; j < 5; j++) if (astState[j] == EXPLOSE) astState[j] = ABSENT;	// si un astroide tait en train d'exploser, le faire disparaitre
	astState[astNumber] = EXPLOSE;	// le nouveau explose !
	for (j = 0; j < 4; j++)
		{
		fragCentre[j].x = astCentre[astNumber].x;
		fragCentre[j].y = astCentre[astNumber].y;	// initialise la position des fragments d'astroide comme tant celle du centre de l'astroide
		fragCentre[j].z = astCentre[astNumber].z;
		fragDist = 0;
		}
}


void move_rings(void)
{
	short i;
	
	for (i = 0; i < 4; i++) 
		{
		astCentre[i].z += 4; 	// 4 est le pas duquel les anneaux avancent  chaque fois
		draw_wire_object(ringVertices, RING_VERT_NB, ringLines, RING_LINES_NB, noEnds, &(astCentre[i]), &astAng[i]);
		}
}


void draw_pathway(void)
{
	// affiche les grandes lignes
	draw_wire_object(pathVertices, PATH_VERT_NB, pathLines, PATH_LINES_NB, noEnds, &(Vertex){-xfield - 50, -10, Camera.z - 11}, &(Angle){0, 0, 0});
	draw_wire_object(pathVertices, PATH_VERT_NB, pathLines, PATH_LINES_NB, noEnds, &(Vertex){+xfield + 50, -10, Camera.z - 11}, &(Angle){0, 0, 0});
}




short missG(short ship)
{
	return ((ship == MISS_NB)? 1 : 0);
}


// dplace la camra suivant le mode de camra
void camera_move(short ship)	
{
	if (camera_mode == FIX)
		{
		Camera.x += sign(0 - Camera.x);
		Camera.y += sign(0 - Camera.y);
		Camera.z += sign(50 - Camera.z); // deplacement de la camra vers le point {0,0,50} si elle n'y est pas dja
		}
	else
		{
		Camera.x += sign(shipCentre[ship].x - Camera.x);
		Camera.y += sign(shipCentre[ship].y + 10 - Camera.y);
		Camera.z += sign(shipCentre[ship].z + 60 - Camera.z); // repositionnement de la camra  chaque fois derriere le missile guid
		}
}

// initialise les paramtres de position de la camra dans une position spcifie
void camera_set(short x, short y, short z)
{
	Camera.x = x;
	Camera.y = y;
	Camera.z = z;
}


// initialise les paramtres de position et d'angle d'un vaisseau
void ship_set(short ship, short x, short y, short z, short angX, short angY, short angZ)
{
	shipCentre[ship].x = x;
	shipCentre[ship].y = y;
	shipCentre[ship].z = z;
	shipAng[ship].x = angX;
	shipAng[ship].y = angY;
	shipAng[ship].z = angZ;
}

// initialise la position du centre de l'cran (pour la fonction draw_wire_object)
void set_screen_center(short x, short y)
{
	ScreenCentre.x = x;
	ScreenCentre.y = y;
}

/******** Fonctions qui ont pour but de localiser ce qui touche  ce qui est dfini dans objects.h ici ***********/

// dessine le vaisseau numro ship (pour les vaisseaux dessins en intro)
void draw_intro_ship(short ship)
{
	draw_wire_object(shipVertices[ship], shipNumVertices[ship], shipLines[ship], shipNumLines[ship], noEnds, &(shipCentre[ship]), &(shipAng[ship]));
}

void turn_ship_y(short ship)
{
	shipAng[ship].y += 2;
}
/*****************************************************************************************************************/

// renvoie le signe d'un nombre
short sign(short number)
{
	if (!number) return 0;
  else return(number > 0 ? 1 : -1);
}


// renvoie le 2^power
unsigned long twoexp(unsigned char power)
{
	unsigned char i;
	unsigned long longNum = 1;
	
	if (power) for(i = 0; i < power; i++) longNum *= 2;
	return longNum;
}



short col_check(short x, short y, short z)
{
	short i;
	
	if (colMod == COMPET)
		{
		for (i = 0; i <= 4; i++) 
			if ((astState[i] == PRESENT || astState[i] == KAMIKAZE) && (square(x - astCentre[i].x) + square(y - astCentre[i].y) + square(z - astCentre[i].z)) < 161)
				return (i + 1);	// retourne le numro de l'astroide en question + 1
		}
	else
		{
		if ((square(x - astCentre[activeRing].x) + square(y - astCentre[activeRing].y)) > 2500 && abs(z - astCentre[activeRing].z) <= 5)
			return 1; // retourne 1 en message
		}
		
	return 0;
}


long square(short number)
{
	long lNumber;
	lNumber = (long) number;
	return (lNumber * lNumber);
}


short find_speed(unsigned char ang)
{
	short speed = 0;
	short compTab[] = {0, 8, 23, 40, 56, 64}; // table de comparaison (les termes de la table sont des angles (echelle 180 <-> 128) dont on utilise les cosinus pour les tests 
		
	while (!((abso(cos128_table[ang]) <= cos128_table[compTab[speed]]) && (abso(cos128_table[ang]) >= cos128_table[compTab[speed + 1]]))) // tant que le cos de ang est plus petit que celui de la position courante dans la table
		speed++;

	return(speed);
}


// Dessine un zoli cadre avec ombre : (x,y) sont les coorodnes du coin haut gauche, 
// dx est le nombre de pixels blanc  l'interieur du cadre horizontalement, dy verticalement
void frame(short x, short y, short dx, short dy, void* plane)
	{
	short i;
	
	for (i = y + 1; i <= y + dy; i++) FastDrawHLine(plane, x + 1, x + dx, i, A_REVERSE); // efface la zone
	
	FastDrawHLine(plane, x + 1, x + dx, y, A_NORMAL);
	FastDrawHLine(plane, x + 1, x + dx + 1, y + dy + 1, A_NORMAL);
	FastDrawLine(plane, x, y + 1, x, y + dy, A_NORMAL);
	FastDrawLine(plane, x + dx + 1, y + 1, x + dx + 1, y + dy + 1, A_NORMAL);
	FastDrawHLine(plane, x + 2, x + dx + 1, y + dy + 2, A_NORMAL);
	FastDrawLine(plane, x + dx + 2, y + 2, x + dx + 2, y + dy + 1, A_NORMAL);
	}

void detail_score(short x, short y, char* string, float score, short ship)
	{
	
	DrawStr(x + 2, y + 2, "Mode :", A_NORMAL);
	if (ctMod == ARCADE)
		DrawStr(x + 25, y + 2, "Arcade", A_NORMAL);
	else
		DrawStr(x + 25, y + 2, "Simulation", A_NORMAL);
	FastDrawHLine(Vscreen, x, x + 112, y + 8, A_NORMAL);
		
	sprintf(buffer, "Distance : %ld", dist);
	DrawStr(x + 2, y + 11, buffer, A_NORMAL);
		
	sprintf(buffer, "Ship size bonus : x %f", shipSizeBonus[ship]);
	DrawStr(x + 2, y + 18, buffer, A_NORMAL);
		
	if (trajMod == SPIRAL) DrawStr(x + 2, y + 25, "Spiral trajectory bonus : x 2", A_NORMAL);
	else DrawStr(x + 2, y + 25, "(No trajectory bonus)", A_NORMAL);
		
	sprintf(buffer, "Asteroids destroyed : + %d x 100", astShoot);
	DrawStr(x + 2, y + 32, buffer, A_NORMAL);
		
	FastDrawHLine(Vscreen, x, x + 112, y + 39, A_NORMAL);
	sprintf(buffer, "%s : %.0f", string, score);
	DrawStr(x + 2, y + 41, buffer, A_NORMAL);
	}


/******************************** Anim ***************************************************/

void intro_anim(short ship, short game_mode)
{
	short y;
	
	for (y = -60; y <= -20; y+=2)
		{
		ship_set(ship, 0, y, -20, 0, 0, 0);
		anim_back(ship, game_mode);
		}
}


/*
unsigned char pos2angle(short xpos, short sens)
{
	if (abso(xpos) < 16)
		return ((unsigned char) (-25 + (25 * sin128_table[(unsigned char)(4*xpos)] >>7)* sens));
	else
		return ((unsigned char) 50 * (xpos > 0 ? 1 : -1) * sens);
}
*/

void anim_back(short ship, short game_mode)
{
	ClrScr();	// effacer l'cran
	draw_wire_object(shipVertices[ship], shipNumVertices[ship], shipLines[ship], shipNumLines[ship], shipEnds[ship], &shipCentre[ship], &shipAng[ship]);	// dessiner le vaisseau
	draw_pathway(); // dessiner les trottoirs
	if (game_mode == COMPET) 
		{
		move_objects(ship);
		draw_ast();
		}
	else
		move_rings();	// dplace et affiche les astroides en mode COMPET, les anneaux en mode TRANING
	memcpy(LCD_MEM, Vscreen, LCD_SIZE); // afficher l'cran virtuel
}

/*
void d3_ship_turn(ship)
{
	char buffer[50];
	
	while (!_keytest(RR_ENTER))
	{
	ClrScr();
	if (_keytest(RR_LEFT)) shipAng[ship].z++;
	if (_keytest(RR_RIGHT)) shipAng[ship].z--;
	if (_keytest(RR_UP)) shipAng[ship].y++;
	if (_keytest(RR_DOWN)) shipAng[ship].y--;
	if (_keytest(RR_ESC)) shipAng[ship].x++;
	if (_keytest(RR_CLEAR)) shipAng[ship].x--;
	sprintf(buffer, "x : %d | y : %d | z : %d |", shipAng[ship].x, shipAng[ship].y, shipAng[ship].z);
	DrawStr(0, 94, buffer, A_NORMAL);
	draw_intro_ship(ship);
	memcpy(LCD_MEM, Vscreen, LCD_SIZE);
	}
}
*/